<?php

namespace Drupal\registry_codelists\Controller;

use \Drupal\Core\Form\FormStateInterface;

class CodelistsValidator {
  /*
   * check if code of code or codelist exists, it could be only a unique value, check if it is.
   * Prüfen ob dein Titel(dient als Code) bereits in Nutzung ist und es sich dabei nicht um eine
   */  
  function validate(&$form, $form_state) {
    $id = $form_state->getFormObject()->getEntity()->id();
    
    $codelistTitles = [];
    $title = strtolower($form_state->getValue('title')[0]['value']);
    
    $nids = \Drupal::entityQuery('node')
            ->condition('type','registry_codelists')
            ->execute();
    $nodes =  \Drupal\node\Entity\Node::loadMultiple($nids);
    
    foreach ($nodes as $node) {
      if($node->id() != $id) {
        array_push($codelistTitles,strtolower($node->getTitle()));
      }
    }
    $nids = \Drupal::entityQuery('node')
            ->condition('type','inspire_codelist')
            ->execute();
    $nodes =  \Drupal\node\Entity\Node::loadMultiple($nids);
    
    foreach ($nodes as $node) {
      if($node->id() != $id) {
        array_push($codelistTitles,strtolower($node->getTitle()));
      };
    }
    
    if (in_array($title,$codelistTitles)) {
      $form_state->setErrorByName('title', t('That code list exists.'));
    };
  }
}
